var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

import _JSXStyle from 'styled-jsx/style';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Fragment } from 'react';
import PropTypes from 'prop-types';
import Color from 'color';

import Calendar from 'react-feather/dist/icons/calendar.js';
import Clock from 'react-feather/dist/icons/clock.js';
import MapPin from 'react-feather/dist/icons/map-pin.js';
import User from 'react-feather/dist/icons/user.js';
import Users from 'react-feather/dist/icons/users.js';

import CalendarEvent from './CalendarEvent.js';
import AddToCalendar from './AddToCalendar.js';
import EventLocation from './EventLocation.js';

import { BREAKPOINTS, OPACITIES, COLORS } from '../constants.js';
import { rgbaOverRgb } from '../utils.js';

var ActiveEvent = function (_CalendarEvent) {
	_inherits(ActiveEvent, _CalendarEvent);

	function ActiveEvent(props) {
		_classCallCheck(this, ActiveEvent);

		var _this = _possibleConstructorReturn(this, (ActiveEvent.__proto__ || Object.getPrototypeOf(ActiveEvent)).call(this, props));

		_this.state = {
			expanded: false
		};

		_this.getEventDate = _this.getEventDate.bind(_this);
		_this.handleOutsideClick = _this.handleOutsideClick.bind(_this);
		_this.handleClick = _this.handleClick.bind(_this);
		return _this;
	}

	_createClass(ActiveEvent, [{
		key: 'getEventDate',
		value: function getEventDate() {
			var event = this.props.event;

			if (!event.end) {
				event.end = event.start;
			}

			var sameDay = event.start.isSame(event.end, 'day');
			var sameDayAllDay = event.allDay && event.start.isSame(event.end.clone().subtract(1, 'day'));
			if (sameDay || sameDayAllDay) {
				return event.start.format('ll');
			} else {
				var startDate = void 0,
				    endDate = void 0;
				if (event.start.isSame(event.end, 'year')) {
					startDate = event.start.format('MMM D');
					endDate = event.end.format('ll');
				} else {
					var dateFormat = 'll';
					startDate = event.start.format(dateFormat);
					endDate = event.end.format(dateFormat);
				}

				return React.createElement(
					'span',
					null,
					React.createElement(
						'time',
						{ className: 'start-date',
							dateTime: event.start.toISOString()
						},
						startDate
					),
					React.createElement(
						'span',
						null,
						' \u2013 '
					),
					React.createElement(
						'time',
						{ className: 'end-date',
							dateTime: event.end.toISOString()
						},
						endDate
					)
				);
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    event = _props.event,
			    showFooter = _props.showFooter;


			var style = void 0;
			if (!this.state.expanded) {
				var rect = this.props.originalElement ? this.props.originalElement.getBoundingClientRect() : {
					top: 1,
					right: 1,
					bottom: 1,
					left: 1,
					width: 0,
					height: 0
				};

				var left = rect.left - 1;
				var top = rect.top - 1;

				var backgroundColor = rgbaOverRgb(Color(event.color).alpha(0.3).array());
				var borderColor = event.color;

				style = {
					width: rect.width * 2,
					height: rect.height * 2,
					transform: 'translate(calc(' + left + 'px - 25%), calc(' + top + 'px - 25%)) scale(0.5)',
					backgroundColor: backgroundColor,
					border: '2px solid ' + borderColor
				};
			}

			var eventTime = this.getEventTime();
			var eventDate = this.getEventDate();
			var className = this.getClassName();
			className += ' active-event';
			if (this.state.expanded) className += ' expanded';

			var headerStyle = void 0;
			if (this.state.expanded) {
				headerStyle = {
					borderBottom: '5px solid ' + event.color
				};
			}

			var hasPresenters = event.presenters && event.presenters.length > 0;

			return React.createElement(
				'div',
				{ key: 'active-event', className: className, style: style,
					ref: function ref(div) {
						return _this2.container = div;
					}, 'data-jsx': 3738762267
				},
				React.createElement(
					'header',
					{ style: headerStyle, ref: function ref(header) {
							return _this2.header = header;
						}, 'data-jsx': 3738762267
					},
					React.createElement(
						'span',
						{ className: 'event-date-time', 'data-jsx': 3738762267
						},
						React.createElement(
							'span',
							{ className: 'event-date', 'data-jsx': 3738762267
							},
							React.createElement(Calendar, null),
							eventDate
						),
						React.createElement(
							'span',
							{ className: 'event-time', 'data-jsx': 3738762267
							},
							React.createElement(Clock, null),
							eventTime
						)
					),
					React.createElement(
						'span',
						{ className: 'event-title', 'data-jsx': 3738762267
						},
						React.createElement(
							'span',
							{ className: 'event-calendar', 'data-jsx': 3738762267
							},
							event.calendar.calname
						),
						event.title
					),
					React.createElement(
						'button',
						{ type: 'button', className: 'close', onClick: this.handleClick,
							title: 'Close active event', 'data-jsx': 3738762267
						},
						'\xD7'
					)
				),
				(event.location || hasPresenters) && React.createElement(
					'div',
					{ className: 'event-meta', 'data-jsx': 3738762267
					},
					event.location && React.createElement(
						'div',
						{ className: 'event-meta-pair', 'data-jsx': 3738762267
						},
						React.createElement(
							'span',
							{ className: 'event-meta-label', 'data-jsx': 3738762267
							},
							React.createElement(MapPin, null),
							'Location'
						),
						React.createElement(
							'span',
							{ className: 'event-meta-value event-location', 'data-jsx': 3738762267
							},
							React.createElement(EventLocation, { location: event.location })
						)
					),
					hasPresenters && React.createElement(
						'div',
						{ className: 'event-meta-pair', 'data-jsx': 3738762267
						},
						React.createElement(
							'span',
							{ className: 'event-meta-label', 'data-jsx': 3738762267
							},
							event.presenters.length === 1 ? React.createElement(
								Fragment,
								null,
								React.createElement(User, null),
								'Presenter'
							) : React.createElement(
								Fragment,
								null,
								React.createElement(Users, null),
								'Presenters'
							)
						),
						React.createElement(
							'ul',
							{ className: 'event-meta-value event-presenters', 'data-jsx': 3738762267
							},
							event.presenters.map(function (presenter) {
								return React.createElement(
									'li',
									{ key: presenter.email, 'data-jsx': 3738762267
									},
									presenter.name
								);
							})
						)
					)
				),
				event.description && React.createElement('div', { className: 'event-desc',
					dangerouslySetInnerHTML: this.markupDescription(event.description),
					'data-jsx': 3738762267
				}),
				showFooter && React.createElement(
					'footer',
					{
						'data-jsx': 3738762267
					},
					React.createElement(AddToCalendar, { event: event })
				),
				React.createElement(_JSXStyle, {
					styleId: 3738762267,
					css: '.active-event[data-jsx="3738762267"] { display:-webkit-box; display:-ms-flexbox; display:flex;-moz-flex-direction: column;-webkit-box-orient: vertical;-webkit-box-direction: normal;-ms-flex-direction: column;flex-direction: column;font-family: \'Noto Sans\', sans-serif;color: rgba(0, 0, 0, ' + OPACITIES.TEXT.PRIMARY + ');padding: 0.5em;margin: 1px;cursor: pointer;-webkit-box-sizing: border-box;box-sizing: border-box;position: fixed;left: 0;top: 0;width: 90vw;height: 90vh;font-size: 1.5em;overflow: hidden;z-index: 100;cursor: auto;visibility: hidden;}header[data-jsx="3738762267"],footer[data-jsx="3738762267"] {-moz-flex-grow: 0;-webkit-box-flex: 0;-ms-flex-positive: 0;flex-grow: 0;background-color: transparent;}.event-calendar[data-jsx="3738762267"] {display: none;font-size: 0.7em;color: rgba(0, 0, 0, ' + OPACITIES.TEXT.SECONDARY + ');}.event-date-time[data-jsx="3738762267"] {margin: 0;text-align: center;}.event-date[data-jsx="3738762267"] {display: none;text-transform: none;}.start-date[data-jsx="3738762267"],.end-date[data-jsx="3738762267"] {white-space: nowrap;}.event-time[data-jsx="3738762267"] {margin: 0;text-transform: uppercase;}.event-title[data-jsx="3738762267"] {word-wrap: break-word;max-width: 80%;}.event-meta[data-jsx="3738762267"] {display: none;}.event-location[data-jsx="3738762267"] {text-align: left;color: rgba(0, 0, 0, ' + OPACITIES.TEXT.SECONDARY + ');}.event-desc[data-jsx="3738762267"] {-moz-flex-grow: 1;-webkit-box-flex: 1;-ms-flex-positive: 1;flex-grow: 1;-ms-flex-negative: 1;flex-shrink: 1;margin: 0;font-size: 0.75em;word-wrap: break-word;white-space: pre-line;}.event.all-day[data-jsx="3738762267"] .event-time[data-jsx="3738762267"] {text-align: center;background: #bfbfbf;border-radius: 2px;padding: 0.15em 0.5em;}header[data-jsx="3738762267"] .close[data-jsx="3738762267"] {position: absolute;right: 0;top: 0;cursor: pointer;font-size: 1em;background: none;border: none;outline: none;color: rgba(0, 0, 0, ' + OPACITIES.TEXT.DISABLED + ');padding: 0.1em;margin: 0.1em;line-height: 0.65;}header[data-jsx="3738762267"] .close[data-jsx="3738762267"]:hover {color: rgba(0, 0, 0, ' + OPACITIES.TEXT.SECONDARY + ');}.active-event.expanded[data-jsx="3738762267"] {font-size: 1.5em;background-color: #fdfdfd;border: 1px solid grey;padding: 0;-webkit-transform: translate(50vw, 50vh) translate(-50%, -50%);-ms-transform: translate(50vw, 50vh) translate(-50%, -50%);transform: translate(50vw, 50vh) translate(-50%, -50%);-webkit-box-shadow: 0 0 20px 0 ' + COLORS.SHADOW + ';box-shadow: 0 0 20px 0 ___styledjsxexpression5___;visibility: visible;}.expanded[data-jsx="3738762267"] header[data-jsx="3738762267"],.expanded[data-jsx="3738762267"] footer[data-jsx="3738762267"] { display:-webkit-box; display:-ms-flexbox; display:flex;-moz-flex-direction: row;-webkit-box-orient: horizontal;-webkit-box-direction: normal;-ms-flex-direction: row;flex-direction: row;-ms-flex-wrap: wrap;flex-wrap: wrap;-webkit-box-shadow: 0 0 5px 0 ' + COLORS.SHADOW + ';box-shadow: 0 0 5px 0 ___styledjsxexpression6___;background-color: ' + COLORS.BACKGROUND + ';overflow: auto;}.expanded[data-jsx="3738762267"] header[data-jsx="3738762267"] {-ms-flex-negative: 0;flex-shrink: 0;padding: 0.5em;}.expanded[data-jsx="3738762267"] footer[data-jsx="3738762267"] {-ms-flex-pack: distribute;justify-content: space-around;-webkit-box-align: center;-ms-flex-align: center;align-items: center;text-align: center;}.expanded[data-jsx="3738762267"] header[data-jsx="3738762267"] svg,.expanded[data-jsx="3738762267"] .event-meta[data-jsx="3738762267"] svg {color: rgba(0, 0, 0, ' + OPACITIES.TEXT.SECONDARY + ');height: 1em;width: 1em;vertical-align: baseline;margin-right: 0.25em;overflow: visible;}.expanded[data-jsx="3738762267"] .event-title[data-jsx="3738762267"],.expanded[data-jsx="3738762267"] .event-date-time[data-jsx="3738762267"] {margin: 0.25em;}.expanded[data-jsx="3738762267"] .event-title[data-jsx="3738762267"] {-moz-order: 1;-webkit-box-ordinal-group: 2;-ms-flex-order: 1;order: 1;-moz-flex-grow: 1;-webkit-box-flex: 1;-ms-flex-positive: 1;flex-grow: 1;max-width: 100%;}.expanded[data-jsx="3738762267"] .event-calendar[data-jsx="3738762267"] {display: block;}.expanded[data-jsx="3738762267"] .event-date-time[data-jsx="3738762267"] {-moz-order: 2;-webkit-box-ordinal-group: 3;-ms-flex-order: 2;order: 2;font-size: 0.9em;}.expanded[data-jsx="3738762267"] .event-date-time[data-jsx="3738762267"] svg {vertical-align: middle;}.expanded[data-jsx="3738762267"] .event-date-time[data-jsx="3738762267"] svg {margin-right: 0.5em;}.expanded[data-jsx="3738762267"] .event-date-time[data-jsx="3738762267"] .event-date[data-jsx="3738762267"],.expanded[data-jsx="3738762267"] .event-date-time[data-jsx="3738762267"] .event-time[data-jsx="3738762267"] { display:-webkit-box; display:-ms-flexbox; display:flex;-moz-flex-direction: row;-webkit-box-orient: horizontal;-webkit-box-direction: normal;-ms-flex-direction: row;flex-direction: row;-webkit-box-align: center;-ms-flex-align: center;align-items: center;}.expanded[data-jsx="3738762267"] .event-date[data-jsx="3738762267"],.expanded[data-jsx="3738762267"] .event-time[data-jsx="3738762267"] {display: block;margin: 0.1em 0.25em;white-space: nowrap;}.expanded[data-jsx="3738762267"] .event-meta[data-jsx="3738762267"] {display: block; display:-webkit-box; display:-ms-flexbox; display:flex;-moz-flex-direction: row;-webkit-box-orient: horizontal;-webkit-box-direction: normal;-ms-flex-direction: row;flex-direction: row;-ms-flex-wrap: wrap;flex-wrap: wrap;-webkit-box-align: space-around;-ms-flex-align: space-around;align-items: space-around;background-color: #fafafa;border-bottom: 1px solid #ccc;font-size: 0.75em;}.expanded[data-jsx="3738762267"] .event-meta-pair[data-jsx="3738762267"] {-moz-flex: 1 1;-webkit-box-flex: 1;-ms-flex: 1 1;flex: 1 1;padding: 0.75em;border: 1px solid #ccc;}.expanded[data-jsx="3738762267"] .event-meta-pair[data-jsx="3738762267"] .event-meta-label[data-jsx="3738762267"] {color: rgba(0, 0, 0, ' + OPACITIES.TEXT.SECONDARY + ');white-space: nowrap;}.expanded[data-jsx="3738762267"] .event-meta-pair[data-jsx="3738762267"] .event-meta-value[data-jsx="3738762267"] {color: rgba(0, 0, 0, ' + OPACITIES.TEXT.PRIMARY + ');}.expanded[data-jsx="3738762267"] .event-desc[data-jsx="3738762267"] {padding: 1em 2em 2em;overflow-y: auto;}.expanded[data-jsx="3738762267"] .event-location[data-jsx="3738762267"] {display: block;}.expanded[data-jsx="3738762267"] .event-presenters[data-jsx="3738762267"] {display: block;padding: 0;margin: 0;}.expanded[data-jsx="3738762267"] .event-presenters[data-jsx="3738762267"] li[data-jsx="3738762267"] {display: inline;}.expanded[data-jsx="3738762267"] .event-presenters[data-jsx="3738762267"] li[data-jsx="3738762267"]:not(:last-child)::after {content: \', \';}@media (min-width: ' + BREAKPOINTS.SMALL_DESKTOP + 'px) {.active-event[data-jsx="3738762267"] {-webkit-transition-duration: 0.15s;transition-duration: 0.15s;-webkit-transition-property: left, top, width, height, transform, background-color, border;-webkit-transition-property:left, top, width, height, background-color, border, -webkit-transform;transition-property:left, top, width, height, background-color, border, -webkit-transform;transition-property:left, top, width, height, transform, background-color, border;transition-property: left, top, width, height, transform, background-color, border, -webkit-transform;max-width: 90vw;max-height: 90vh;width: auto;height: auto;visibility: visible;}header[data-jsx="3738762267"],footer[data-jsx="3738762267"] {-webkit-transition-duration: 0.15s;transition-duration: 0.15s;-webkit-transition-property: background-color, border;transition-property: background-color, border;}.active-event.expanded[data-jsx="3738762267"] {font-size: 2em;}.event-date-time[data-jsx="3738762267"] {text-align: right;}.expanded[data-jsx="3738762267"] header[data-jsx="3738762267"] {-webkit-box-pack: justify;-ms-flex-pack: justify;justify-content: space-between;-ms-flex-wrap: nowrap;flex-wrap: nowrap;text-align: left;}.expanded[data-jsx="3738762267"] .event-title[data-jsx="3738762267"] {margin-right: 1em;font-size: 1.25em;}.expanded[data-jsx="3738762267"] .event-meta[data-jsx="3738762267"] {font-size: 0.6em;}.expanded[data-jsx="3738762267"] .event-meta-pair[data-jsx="3738762267"] {padding: 0.75em 1em;}.expanded[data-jsx="3738762267"] .event-date-time[data-jsx="3738762267"] {-moz-flex-direction: column;-webkit-box-orient: vertical;-webkit-box-direction: normal;-ms-flex-direction: column;flex-direction: column;-webkit-box-pack: end;-ms-flex-pack: end;justify-content: flex-end;}.expanded[data-jsx="3738762267"] .event-date-time[data-jsx="3738762267"] {margin-left: 1em;}}'
				})
			);
		}
	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			var _this3 = this;

			window.requestAnimationFrame(function () {
				window.requestAnimationFrame(function () {
					_this3.setState({ expanded: true });

					if ('parentIFrame' in window) {
						window.parentIFrame.getPageInfo(function (parentPage) {
							var middleOfParentViewport = parentPage.scrollTop + parentPage.clientHeight / 2 - parentPage.offsetTop;

							var y = middleOfParentViewport > parentPage.clientHeight / 2 ? middleOfParentViewport < window.innerHeight - parentPage.clientHeight / 2 ? middleOfParentViewport + 'px' : '100vh - 50% - 10px' : '50% + 10px';

							var containerMaxHeight = parentPage.clientHeight * 0.9 - 50;
							_this3.container.style.maxHeight = containerMaxHeight + 'px';
							_this3.container.style.transform = 'translate(calc(50vw - 50%), calc(' + y + ' - 50%))';
						});
					}
					document.addEventListener('click', _this3.handleOutsideClick);
				});
			});
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			document.removeEventListener('click', this.handleOutsideClick);
		}
	}, {
		key: 'handleClick',
		value: function handleClick() {
			var _this4 = this;

			window.requestAnimationFrame(function () {
				_this4.setState({ expanded: false }, function () {
					if ('parentIFrame' in window) {
						window.parentIFrame.getPageInfo(false);
					}

					var timeout = window.innerWidth >= BREAKPOINTS.SMALL_DESKTOP ? 140 : 10;

					window.setTimeout(_this4.props.onClose, timeout);
				});
			});
		}
	}, {
		key: 'handleOutsideClick',
		value: function handleOutsideClick(event) {
			var _this5 = this;

			if (event.defaultPrevented) return;

			window.requestAnimationFrame(function () {
				var rect = _this5.container.getBoundingClientRect();
				if (event.clientX < rect.left || event.clientX > rect.right || event.clientY < rect.top || event.clientY > rect.bottom) _this5.handleClick();
			});
		}
	}]);

	return ActiveEvent;
}(CalendarEvent);

export default ActiveEvent;


ActiveEvent.propTypes = {
	event: PropTypes.object.isRequired,
	originalElement: PropTypes.object,
	onClose: PropTypes.func,
	showFooter: PropTypes.bool
};

ActiveEvent.defaultProps = {
	showFooter: false
};