import _JSXStyle from 'styled-jsx/style';
import React from 'react';
import PropTypes from 'prop-types';
import Color from 'color';

import { COLORS, OPACITIES } from '../constants.js';
import { fullCalendarToIcsUrl, fullCalendarToGoogleUrl } from '../utils.js';

var buttonHoverBackgroundColor = new Color(COLORS.ACCENT).alpha(OPACITIES.SECONDARY);

var AddToCalendar = function AddToCalendar(_ref) {
	var event = _ref.event;
	return React.createElement(
		'div',
		{ className: 'add-to-calendar', 'data-jsx': 3477517257
		},
		'Add event to calendar',
		React.createElement(
			'div',
			{ className: 'buttons-container', 'data-jsx': 3477517257
			},
			React.createElement(
				'a',
				{ href: fullCalendarToGoogleUrl(event),
					target: '_blank', rel: 'noopener noreferrer', 'data-jsx': 3477517257
				},
				'Google Calendar'
			),
			React.createElement(
				'a',
				{ href: fullCalendarToIcsUrl(event), 'data-jsx': 3477517257
				},
				'Outlook / Other'
			)
		),
		React.createElement(_JSXStyle, {
			styleId: 3477517257,
			css: '.add-to-calendar[data-jsx="3477517257"] {-moz-flex-grow: 1;-webkit-box-flex: 1;-ms-flex-positive: 1;flex-grow: 1;font-size: 0.75em;}.buttons-container[data-jsx="3477517257"] { display:-webkit-box; display:-ms-flexbox; display:flex;-ms-flex-pack: distribute;justify-content: space-around;-ms-flex-wrap: wrap;flex-wrap: wrap;}a[data-jsx="3477517257"] {text-decoration: none;border-radius: 4px;padding: 0.25em 0.5em;margin: 0.25em;border: 2px solid ' + COLORS.ACCENT + ';color: ' + COLORS.ACCENT + ';}a[data-jsx="3477517257"]:hover {color: white;background-color: ' + buttonHoverBackgroundColor + ';}'
		})
	);
};

AddToCalendar.propTypes = {
	event: PropTypes.shape({
		start: PropTypes.object,
		end: PropTypes.object,
		title: PropTypes.string,
		description: PropTypes.string,
		location: PropTypes.string,
		url: PropTypes.string
	})
};

export default AddToCalendar;