var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

import _JSXStyle from 'styled-jsx/style';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { withRouter } from 'react-router';
import { NavLink } from 'react-router-dom';

import FullCalendar from './FullCalendar.js';
import ActiveEvent from './ActiveEvent.js';
import CalendarLegend from './CalendarLegend.js';
import CustomGroupSelector from './CustomGroupSelector.js';
import Subscription from './Subscription.js';
import Options from './Options.js';
import CalendarTree from './CalendarTree.js';

import { BREAKPOINTS } from '../constants.js';
import { getCalendars, filterHiddenCalendars, replaceCalendarMacros, getAliases } from '../utils.js';

var App = function (_Component) {
	_inherits(App, _Component);

	function App(props) {
		_classCallCheck(this, App);

		var _this = _possibleConstructorReturn(this, (App.__proto__ || Object.getPrototypeOf(App)).call(this, props));

		_this.state = {
			TRUSTED_ORIGINS: [],
			GOOGLE_CALENDAR_API_KEY: '',
			calendars: {},
			calendarGroups: {},
			calendarTree: null,
			calendarGroupTree: null,
			aliases: null,
			activeEvent: null,
			activeEventOriginalElement: null,
			loaded: null
		};

		_this.redirectAlias = _this.redirectAlias.bind(_this);
		_this.handleSetActiveEventId = _this.handleSetActiveEventId.bind(_this);
		_this.handleSetActiveEvent = _this.handleSetActiveEvent.bind(_this);
		_this.handleUnsetActiveEvent = _this.handleUnsetActiveEvent.bind(_this);
		_this.handleChangeCustomCalendarIds = _this.handleChangeCustomCalendarIds.bind(_this);
		return _this;
	}

	_createClass(App, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			var _this2 = this;

			fetch(this.props.envFile).then(function (response) {
				return response.json();
			}).then(function (dotenv) {
				var searchParams = new URLSearchParams(_this2.props.search.slice(1));
				var keys = searchParams.getAll('key');

				dotenv = replaceCalendarMacros(dotenv);
				dotenv = filterHiddenCalendars(dotenv, keys);
				var aliases = getAliases(dotenv);
				_this2.setState(Object.assign(dotenv, { loaded: true, aliases: aliases }), function () {
					_this2.redirectAlias();
				});

				if (dotenv.GOOGLE_ANALYTICS_TRACKING_ID && window.ga) {
					window.ga('create', dotenv.GOOGLE_ANALYTICS_TRACKING_ID, 'auto');
					window.ga('send', 'pageview');
				}
			}).catch(function (err) {
				console.error(err);
				_this2.setState({ loaded: false });
			});
		}
	}, {
		key: 'UNSAFE_componentWillReceiveProps',
		value: function UNSAFE_componentWillReceiveProps(nextProps) {
			if (!nextProps.eventId && this.state.activeEvent) this.handleUnsetActiveEvent(false);
			this.redirectAlias();
		}
	}, {
		key: 'render',
		value: function render() {
			var _this3 = this;

			var _props = this.props,
			    calendarId = _props.calendarId,
			    eventId = _props.eventId,
			    search = _props.search,
			    location = _props.location,
			    history = _props.history;

			var params = new URLSearchParams(search);
			var customCalendar = {
				calname: 'Custom Group',
				calendars: params.getAll('customCalendar')
			};

			var _getCalendars = getCalendars(calendarId, this.state.calendars, this.state.calendarGroups, customCalendar),
			    calendar = _getCalendars.calendar,
			    calendars = _getCalendars.calendars,
			    calendarMap = _getCalendars.calendarMap,
			    eventSources = _getCalendars.eventSources;

			var allCalendarLikes = Object.assign({}, this.state.calendars, this.state.calendarGroups);
			var searchParams = new URLSearchParams(this.props.search.slice(1));
			var calendarView = searchParams.get('view');
			var defaultDate = searchParams.get('date');

			if (calendar && calendars && eventSources) {
				var activeEventNode = this.state.activeEvent ? React.createElement(ActiveEvent, { event: this.state.activeEvent,
					originalElement: this.state.activeEventOriginalElement,
					onClose: this.handleUnsetActiveEvent }) : null;

				var groupedCalendarListItems = React.createElement(
					CalendarTree,
					{ calendars: allCalendarLikes,
						calendarTree: this.state.calendarGroupTree,
						container: 'section',
						label: React.createElement(
							'h3',
							null,
							'Calendar groups'
						),
						keyPrefix: 'calendar-group-list-tree',
						render: function render(id, cal) {
							return React.createElement(
								'li',
								{ key: 'grouped-calendar-list-items-' + id },
								React.createElement(
									NavLink,
									{ to: { pathname: '/' + id, search: search } },
									cal.calname
								)
							);
						} },
					React.createElement(
						'li',
						{ key: 'custom' },
						React.createElement(
							NavLink,
							{ to: { pathname: '/custom', search: search } },
							'Custom Group'
						)
					)
				);

				var calendarListTree = calendarId === 'custom' ? React.createElement(CustomGroupSelector, { calendars: this.state.calendars,
					calendarTree: this.state.calendarTree,
					customCalendarIds: customCalendar.calendars,
					handleChangeCustomCalendarIds: this.handleChangeCustomCalendarIds }) : React.createElement(CalendarTree, { calendars: calendarMap,
					container: 'section',
					label: React.createElement(
						'h3',
						null,
						'Calendars in ',
						calendar.calname
					),
					keyPrefix: 'calendar-list-tree',
					render: function render(id, cal) {
						return React.createElement(
							'li',
							{ key: 'calendar-list-items-' + id },
							React.createElement(
								NavLink,
								{ to: { pathname: '/' + id, search: search } },
								cal.calname
							)
						);
					} });

				// `${window.location.origin}/${this.props.icsFilename}${window.location.search}`

				var icsUrl = void 0;
				if (calendar.url && !calendar.calendars) {
					icsUrl = calendar.url;
				} else {
					var _search = window.location.search;
					var filename = void 0;

					if (calendarId === 'custom') {
						filename = 'combine.ics';

						if (_search) _search += '&';else _search = '?';

						_search += customCalendar.calendars.filter(function (id) {
							return id in _this3.state.calendars;
						}).map(function (calId) {
							var cal = _this3.state.calendars[calId];
							if (cal.url) {
								return 'urls[]=' + cal.url;
							} else if (cal.subCalendars) {
								return cal.subCalendars.map(function (subCal) {
									return 'urls[]=' + subCal.url;
								}).join('&');
							}
						}).join('&');
					} else {
						filename = calendarId + '.ics';
					}

					icsUrl = window.location.origin + '/' + filename + _search;
				}

				var showCalendarNames = searchParams.has('showCalendarNames') && searchParams.get('showCalendarNames') !== 'false';
				var showLocations = searchParams.has('showLocations') && searchParams.get('showLocations') !== 'false';
				var showDescriptions = searchParams.has('showDescriptions') && searchParams.get('showDescriptions') !== 'false';
				var showPresenters = searchParams.has('showPresenters') && searchParams.get('showPresenters') !== 'false';

				return React.createElement(
					'div',
					{ 'data-iframe-height': true, 'data-jsx': 700757479
					},
					activeEventNode,
					React.createElement(
						'h1',
						{
							'data-jsx': 700757479
						},
						calendar.calname
					),
					React.createElement(FullCalendar, { trustedOrigins: this.state.TRUSTED_ORIGINS,
						apiKey: this.state.GOOGLE_CALENDAR_API_KEY,
						eventSources: eventSources,
						customCalendars: customCalendar.calendars,
						setActiveEvent: this.handleSetActiveEvent,
						setActiveEventId: this.handleSetActiveEventId,
						defaultView: calendarView,
						defaultDate: defaultDate,
						eventId: eventId,
						location: location,
						history: history,
						showCalendarNames: showCalendarNames,
						showLocations: showLocations,
						showDescriptions: showDescriptions,
						showPresenters: showPresenters
					}),
					React.createElement(CalendarLegend, { calendars: calendars, calname: calendar.calname }),
					React.createElement(Subscription, { url: icsUrl }),
					(groupedCalendarListItems || calendarListTree) && React.createElement(
						'div',
						{ className: 'calendar-nav-container', 'data-jsx': 700757479
						},
						React.createElement(
							'h2',
							{
								'data-jsx': 700757479
							},
							'Other calendars'
						),
						React.createElement(
							'nav',
							{ className: 'calendar-nav', 'data-jsx': 700757479
							},
							groupedCalendarListItems,
							calendarListTree
						)
					),
					React.createElement(Options, { location: location, history: history }),
					React.createElement(_JSXStyle, {
						styleId: 700757479,
						css: 'h1[data-jsx="700757479"] {font-size: 2.75em;font-weight: 500;text-align: center;}h2[data-jsx="700757479"] {font-size: 2em;font-weight: normal;}a.active {pointer-events: none;text-decoration: none;cursor: auto;color: black;}.calendar-nav-container[data-jsx="700757479"] {padding: 0 2em;}@media (min-width: ' + BREAKPOINTS.SMALL_DESKTOP + 'px) {.calendar-nav-container[data-jsx="700757479"] {padding: 0 3em;}}@media (min-width: ' + BREAKPOINTS.LARGE_DESKTOP + 'px) {.calendar-nav-container[data-jsx="700757479"] {padding: 0 4em;}}.calendar-nav[data-jsx="700757479"] { display:-webkit-box; display:-ms-flexbox; display:flex;-moz-flex-direction: row;-webkit-box-orient: horizontal;-webkit-box-direction: normal;-ms-flex-direction: row;flex-direction: row;-ms-flex-wrap: wrap;flex-wrap: wrap;-ms-flex-pack: distribute;justify-content: space-around;}.calendar-nav[data-jsx="700757479"] section[data-jsx="700757479"] {-moz-flex-grow: 0;-webkit-box-flex: 0;-ms-flex-positive: 0;flex-grow: 0;-ms-flex-negative: 1;flex-shrink: 1;min-width: 15em;}@media print {h1[data-jsx="700757479"] {margin: 0;font-size: 2em;}h2[data-jsx="700757479"] {font-size: 1.5em;}.calendar-nav-container[data-jsx="700757479"] {display: none;}}'
					})
				);
			} else {
				switch (this.state.loaded) {
					case null:
					default:
						return React.createElement(
							'div',
							{ className: 'loading-container', 'data-jsx': 715160364
							},
							React.createElement('img', { src: '/assets/spinner.gif', alt: 'Loading', 'data-jsx': 715160364
							}),
							React.createElement(_JSXStyle, {
								styleId: 715160364,
								css: '.loading-container[data-jsx="715160364"] { display:-webkit-box; display:-ms-flexbox; display:flex;-webkit-box-pack: center;-ms-flex-pack: center;justify-content: center;-webkit-box-align: center;-ms-flex-align: center;align-items: center;text-align: center;width: 100%;height: 100%;}'
							})
						);
					case true:
						return React.createElement(
							'p',
							null,
							'No calendar ',
							React.createElement(
								'code',
								null,
								calendarId
							),
							' found.'
						);
					case false:
						return React.createElement(
							'p',
							null,
							'There was a problem loading calendar data.'
						);
				}
			}
		}
	}, {
		key: 'redirectAlias',
		value: function redirectAlias() {
			var aliases = this.state.aliases;
			var _props2 = this.props,
			    calendarId = _props2.calendarId,
			    history = _props2.history,
			    location = _props2.location;


			if (aliases && aliases.has(calendarId)) {
				var newLocation = Object.assign({}, location, {
					pathname: '/' + aliases.get(calendarId)
				});

				history.push(newLocation);
			}
		}
	}, {
		key: 'handleSetActiveEventId',
		value: function handleSetActiveEventId(id, container) {
			var newLocation = Object.assign({}, this.props.location);
			newLocation.hash = id;

			this.props.history.push(newLocation);

			if (container) {
				this.setState({
					activeEventOriginalElement: container
				});
			}
		}
	}, {
		key: 'handleSetActiveEvent',
		value: function handleSetActiveEvent(calEvent) {

			this.setState({
				activeEvent: calEvent
			});
		}
	}, {
		key: 'handleUnsetActiveEvent',
		value: function handleUnsetActiveEvent() {
			var shouldPush = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

			if (shouldPush) {
				this.handleSetActiveEventId('');
			}

			this.setState({
				activeEvent: null,
				activeEventOriginalPosition: null
			});
		}
	}, {
		key: 'handleChangeCustomCalendarIds',
		value: function handleChangeCustomCalendarIds(event) {
			var checkbox = event.target;

			var params = new URLSearchParams(this.props.location.search);
			var customCalendars = params.getAll('customCalendar');

			if (checkbox.checked) customCalendars.push(checkbox.value);else customCalendars.splice(customCalendars.indexOf(checkbox.value), 1);

			params.delete('customCalendar');
			var _iteratorNormalCompletion = true;
			var _didIteratorError = false;
			var _iteratorError = undefined;

			try {
				for (var _iterator = customCalendars[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
					var cal = _step.value;

					params.append('customCalendar', cal);
				}
			} catch (err) {
				_didIteratorError = true;
				_iteratorError = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion && _iterator.return) {
						_iterator.return();
					}
				} finally {
					if (_didIteratorError) {
						throw _iteratorError;
					}
				}
			}

			this.props.history.push(Object.assign({}, this.props.location, { search: params.toString() }));
		}
	}]);

	return App;
}(Component);

App.propTypes = {
	envFile: PropTypes.string.isRequired,
	calendarId: PropTypes.string,
	eventId: PropTypes.string,
	search: PropTypes.string,

	location: PropTypes.shape({
		hash: PropTypes.string
	}),
	history: PropTypes.shape({
		push: PropTypes.func.isRequired,
		listen: PropTypes.func.isRequired
	}).isRequired
};

export default withRouter(App);