var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

import _JSXStyle from 'styled-jsx/style';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Color from 'color';
import striptags from 'striptags';
import LinkifyIt from 'linkify-it';
import moment from 'moment-timezone';

import MapPin from 'react-feather/dist/icons/map-pin.js';
import User from 'react-feather/dist/icons/user.js';
import Users from 'react-feather/dist/icons/users.js';

import { OPACITIES } from '../constants.js';

var linkify = new LinkifyIt();

var CalendarEvent = function (_Component) {
	_inherits(CalendarEvent, _Component);

	function CalendarEvent(props) {
		_classCallCheck(this, CalendarEvent);

		var _this = _possibleConstructorReturn(this, (CalendarEvent.__proto__ || Object.getPrototypeOf(CalendarEvent)).call(this, props));

		_this.handleClick = _this.handleClick.bind(_this);
		_this.getEventTime = _this.getEventTime.bind(_this);
		_this.getClassName = _this.getClassName.bind(_this);
		return _this;
	}

	_createClass(CalendarEvent, [{
		key: 'markupDescription',
		value: function markupDescription(description) {
			description = striptags(description, ['a', 'i', 'b', 'br', 'p']);

			if (description && linkify.test(description)) {
				linkify.match(description).map(function (match) {
					description = description.replace(match.raw, '<a href="' + match.url + '" target="_blank" rel="noopener noreferrer">' + match.text + '</a>');
				});
			}

			return { __html: description };
		}
	}, {
		key: 'renderEventLocation',
		value: function renderEventLocation(location) {
			if (!location) return;

			if (typeof location === 'string') return location;
			if (location.name) return location.name;
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    event = _props.event,
			    showLocation = _props.showLocation,
			    showCalendarName = _props.showCalendarName,
			    showDescription = _props.showDescription,
			    showPresenters = _props.showPresenters;


			var eventTime = this.getEventTime();
			var className = this.getClassName();

			var color = Color(event.color);

			var style = {
				border: '1px solid ' + color.rgb().string(),
				backgroundColor: color.alpha(0.3).rgb().string()
			};

			var ContainerElement = this.props.containerElement || 'div';

			return React.createElement(
				ContainerElement,
				{ className: className, style: style,
					title: event.calendar.calname,
					onClick: this.handleClick,
					ref: function ref(container) {
						return _this2.container = container;
					} },
				React.createElement(
					'span',
					{ className: 'event-time', 'data-jsx': 453879503
					},
					eventTime
				),
				React.createElement(
					'span',
					{ className: 'event-title', 'data-jsx': 453879503
					},
					showCalendarName && React.createElement(
						'span',
						{ className: 'event-calendar', 'data-jsx': 453879503
						},
						event.calendar.calname
					),
					event.title
				),
				showLocation && event.location && React.createElement(
					'span',
					{ className: 'event-location', 'data-jsx': 453879503
					},
					React.createElement(MapPin, null),
					this.renderEventLocation(event.location)
				),
				showPresenters && event.presenters && event.presenters.length > 0 && React.createElement(
					'span',
					{ className: 'event-presenters', 'data-jsx': 453879503
					},
					event.presenters.length === 1 ? React.createElement(User, null) : React.createElement(Users, null),
					event.presenters.map(function (presenter) {
						return presenter.name;
					}).join(', ')
				),
				showDescription && event.description && React.createElement('div', { className: 'event-desc',
					dangerouslySetInnerHTML: this.markupDescription(event.description), 'data-jsx': 453879503
				}),
				React.createElement(_JSXStyle, {
					styleId: 453879503,
					css: '.event {font-family: \'Noto Sans\', sans-serif;color: rgba(0, 0, 0, ' + OPACITIES.TEXT.PRIMARY + ');padding: 0.5em;margin: 1px;cursor: pointer;font-size: 0.75em;}.event-calendar[data-jsx="453879503"] {margin: 0 0.5em 0 0;color: rgba(0, 0, 0, ' + OPACITIES.TEXT.SECONDARY + ');}.event-location[data-jsx="453879503"] {display: block;margin: 0.5em 0 0;color: rgba(0, 0, 0, ' + OPACITIES.TEXT.SECONDARY + ');}.event-presenters[data-jsx="453879503"] {display: block;margin: 0.5em 0 0;color: rgba(0, 0, 0, ' + OPACITIES.TEXT.SECONDARY + ');}.event svg {width: 1em;height: 1em;overflow: visible;margin-right: 0.25em;}.event-time[data-jsx="453879503"] {margin: 0 0.5em 0 0;text-transform: uppercase;}.event-title[data-jsx="453879503"] {word-wrap: break-word;}.event-desc[data-jsx="453879503"] {font-size: 0.9em;word-wrap: break-word;white-space: pre-line;color: rgba(0, 0, 0, ' + OPACITIES.TEXT.SECONDARY + ');}.event-desc[data-jsx="453879503"],.event-desc[data-jsx="453879503"] p[data-jsx="453879503"] {margin-top: 1em;margin-bottom: 1em;}.event.all-day .event-time[data-jsx="453879503"] {display: inline-block;text-align: center;background: #bfbfbf;border-radius: 2px;padding: 0.15em 0.5em;white-space: nowrap;}@media print {.event {font-size: 0.6em;}}'
				})
			);
		}
	}, {
		key: 'getEventTime',
		value: function getEventTime() {
			var eventTime = void 0;

			try {
				var event = this.props.event;

				if (event.allDay) {
					eventTime = React.createElement(
						'span',
						null,
						'All day'
					);
				} else {
					var start = moment(event.start).tz(moment.tz.guess());
					var end = moment(event.end).tz(moment.tz.guess());
					var startTime = start.format('h');
					if (start.get('minute') !== 0) startTime += ':' + start.format('mm');
					if (start.format('A') !== end.format('A')) startTime += ' ' + start.format('A');
					var endTime = end.get('minute') === 0 ? end.format('h A') : end.format('LT');

					eventTime = React.createElement(
						'span',
						null,
						React.createElement(
							'time',
							{ className: 'event-time-start',
								dateTime: start.toISOString()
							},
							startTime
						),
						' \u2013 ',
						React.createElement(
							'time',
							{ className: 'event-time-end',
								dateTime: end.toISOString()
							},
							endTime
						)
					);
				}
			} catch (err) {
				console.error(err);
			}

			return eventTime;
		}
	}, {
		key: 'getClassName',
		value: function getClassName() {
			var className = 'event';
			if (this.props.event.allDay) className += ' all-day';

			return className;
		}
	}, {
		key: 'handleClick',
		value: function handleClick(clickEvent) {
			clickEvent.preventDefault();

			var _props2 = this.props,
			    event = _props2.event,
			    setActiveEvent = _props2.setActiveEvent,
			    setActiveEventId = _props2.setActiveEventId;


			setActiveEventId(event.id, this.container);
			setActiveEvent(event);
		}
	}]);

	return CalendarEvent;
}(Component);

export default CalendarEvent;


CalendarEvent.propTypes = {
	setActiveEvent: PropTypes.func.isRequired,
	setActiveEventId: PropTypes.func.isRequired,
	event: PropTypes.object.isRequired,
	view: PropTypes.object,
	containerElement: PropTypes.string,
	showLocation: PropTypes.bool,
	showCalendarName: PropTypes.bool,
	showDescription: PropTypes.bool,
	showPresenters: PropTypes.bool
};

CalendarEvent.defaultProps = {
	showLocation: false,
	showCalendarName: false,
	showDescription: false,
	showPresenters: false
};