import React from 'react';

import CalendarTree from './CalendarTree.js';

var CustomGroupSelector = function CustomGroupSelector(props) {
	return React.createElement(CalendarTree, { calendars: props.calendars,
		calendarTree: props.calendarTree,
		keyPrefix: 'custom-group-selector',
		container: 'div',
		label: React.createElement(
			'h3',
			null,
			'Calendars in Custom Group'
		),
		render: function render(calendarId) {
			return React.createElement(
				'li',
				{ key: 'custom-' + calendarId },
				React.createElement(
					'label',
					null,
					React.createElement('input', { type: 'checkbox', value: calendarId,
						checked: props.customCalendarIds.includes(calendarId),
						onChange: props.handleChangeCustomCalendarIds }),
					props.calendars[calendarId].calname
				)
			);
		} });
};

export default CustomGroupSelector;