var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

import _JSXStyle from 'styled-jsx/style';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';

import * as localforage from 'localforage';

import { camelCaseToWords } from '../utils.js';

var Options = function (_Component) {
	_inherits(Options, _Component);

	function Options() {
		_classCallCheck(this, Options);

		var _this = _possibleConstructorReturn(this, (Options.__proto__ || Object.getPrototypeOf(Options)).call(this));

		_this.options = ['showCalendarNames', 'showLocations', 'showPresenters', 'showDescriptions'];

		_this.handleOptionChange = _this.handleOptionChange.bind(_this);
		_this.getStoredOptions = _this.getStoredOptions.bind(_this);
		_this.toggleOption = _this.toggleOption.bind(_this);
		return _this;
	}

	_createClass(Options, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.getStoredOptions();
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var params = new URLSearchParams(location.search);

			var inputs = this.options.map(function (option) {
				return React.createElement(
					'label',
					{ key: option },
					React.createElement('input', { type: 'checkbox', value: option,
						checked: params.has(option),
						onChange: _this2.handleOptionChange }),
					camelCaseToWords(option)
				);
			});

			return React.createElement(
				'div',
				{
					'data-jsx': 1250369456
				},
				inputs,
				React.createElement(_JSXStyle, {
					styleId: 1250369456,
					css: 'div[data-jsx="1250369456"] { display:-webkit-box; display:-ms-flexbox; display:flex;-moz-flex-direction: row;-webkit-box-orient: horizontal;-webkit-box-direction: normal;-ms-flex-direction: row;flex-direction: row;-ms-flex-wrap: wrap;flex-wrap: wrap;-ms-flex-pack: distribute;justify-content: space-around;}'
				})
			);
		}
	}, {
		key: 'getStoredOptions',
		value: function getStoredOptions() {
			var _this3 = this;

			var promises = this.options.map(function (option) {
				return localforage.getItem(option).then(function (val) {
					return [option, val];
				}).catch(function (err) {
					console.error('Failed fetching stored option for ' + option, err);
				});
			});

			Promise.all(promises).then(function (options) {
				var _props = _this3.props,
				    location = _props.location,
				    history = _props.history;

				var params = new URLSearchParams(location.search);

				var paramsChanged = false;
				var _iteratorNormalCompletion = true;
				var _didIteratorError = false;
				var _iteratorError = undefined;

				try {
					for (var _iterator = options[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
						var _step$value = _slicedToArray(_step.value, 2),
						    option = _step$value[0],
						    value = _step$value[1];

						if (value && !params.has(option)) {
							params.set(option, true);
							paramsChanged = true;
						}
					}
				} catch (err) {
					_didIteratorError = true;
					_iteratorError = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion && _iterator.return) {
							_iterator.return();
						}
					} finally {
						if (_didIteratorError) {
							throw _iteratorError;
						}
					}
				}

				if (paramsChanged) {
					var newLocation = Object.assign({}, location, { search: '?' + params.toString() });
					history.push(newLocation);
				}
			}).catch(function (err) {
				console.error("Failed fetching all options somehow? Don't think this should happen", err);
			});
		}
	}, {
		key: 'handleOptionChange',
		value: function handleOptionChange(event) {
			var option = event.target.value;
			this.toggleOption(option);
		}
	}, {
		key: 'toggleOption',
		value: function toggleOption(option, checked) {
			var _props2 = this.props,
			    location = _props2.location,
			    history = _props2.history;

			var params = new URLSearchParams(location.search);
			var enabled = checked != null ? checked : !params.has(option);
			if (enabled) {
				params.set(option, true);
				localforage.setItem(option, true).catch(function (err) {
					console.error('Failed setting stored option ' + option, err);
				});
			} else {
				params.delete(option);
				localforage.removeItem(option).catch(function (err) {
					console.error('Failed removing stored option ' + option, err);
				});
			}

			var newLocation = Object.assign({}, location, { search: '?' + params.toString() });
			history.push(newLocation);
		}
	}]);

	return Options;
}(Component);

export default Options;


Options.propTypes = {
	location: PropTypes.shape({
		search: PropTypes.string
	}),
	history: PropTypes.shape({
		push: PropTypes.func.isRequired
	})
};