/** @format */
/* eslint-env node */

var ICAL = require("ical.js");

var _require = require("../package.json"),
    icalMerger = _require.icalMerger;

function merge(inputs) {
	var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	if (!Array.isArray(inputs)) inputs = [].concat(Array.prototype.slice.call(arguments));

	var calendar = void 0;
	var _iteratorNormalCompletion = true;
	var _didIteratorError = false;
	var _iteratorError = undefined;

	try {
		for (var _iterator = inputs[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
			var input = _step.value;

			try {
				var jcal = ICAL.parse(input);
				var cal = new ICAL.Component(jcal);

				if (!calendar) {
					calendar = cal;
					calendar.updatePropertyWithValue("prodid", icalMerger.prodid);
					calendar.updatePropertyWithValue("version", icalMerger.version);

					if (options.calname) calendar.updatePropertyWithValue("x-wr-calname", options.calname);
					if (options.timezone) calendar.updatePropertyWithValue("x-wr-timezone", options.timezone);
					if (options.caldesc) calendar.updatePropertyWithValue("x-wr-caldesc", options.caldesc);
				} else {
					var _iteratorNormalCompletion2 = true;
					var _didIteratorError2 = false;
					var _iteratorError2 = undefined;

					try {
						for (var _iterator2 = cal.getAllSubcomponents("vevent")[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
							var vevent = _step2.value;

							calendar.addSubcomponent(vevent);
						}
					} catch (err) {
						_didIteratorError2 = true;
						_iteratorError2 = err;
					} finally {
						try {
							if (!_iteratorNormalCompletion2 && _iterator2.return) {
								_iterator2.return();
							}
						} finally {
							if (_didIteratorError2) {
								throw _iteratorError2;
							}
						}
					}
				}
			} catch (e) {
				console.error("Failed to merge: " + e + "\n\nWith input: " + input);
			}
		}
	} catch (err) {
		_didIteratorError = true;
		_iteratorError = err;
	} finally {
		try {
			if (!_iteratorNormalCompletion && _iterator.return) {
				_iterator.return();
			}
		} finally {
			if (_didIteratorError) {
				throw _iteratorError;
			}
		}
	}

	if (!calendar) {
		console.error("No icals parsed successfully");
		return;
	}

	return calendar.toString();
}

module.exports = merge;
