var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

import moment from 'moment';
import colorString from 'color-string';

import { isCalendarVisible, getDeepCalendarIdsFromSubGroups } from './server-utils.js';

export function getAliases(config) {
	var aliasMap = new Map();

	// $FlowFixMe: https://github.com/facebook/flow/issues/2221
	var _iteratorNormalCompletion = true;
	var _didIteratorError = false;
	var _iteratorError = undefined;

	try {
		for (var _iterator = Object.entries(config.calendars)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
			var _step$value = _slicedToArray(_step.value, 2),
			    calendarId = _step$value[0],
			    _calendar = _step$value[1];

			if (_calendar.aliases) {
				var _iteratorNormalCompletion3 = true;
				var _didIteratorError3 = false;
				var _iteratorError3 = undefined;

				try {
					for (var _iterator3 = _calendar.aliases[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
						var alias = _step3.value;

						aliasMap.set(alias, calendarId);
					}
				} catch (err) {
					_didIteratorError3 = true;
					_iteratorError3 = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion3 && _iterator3.return) {
							_iterator3.return();
						}
					} finally {
						if (_didIteratorError3) {
							throw _iteratorError3;
						}
					}
				}
			}
		}

		// $FlowFixMe: https://github.com/facebook/flow/issues/2221
	} catch (err) {
		_didIteratorError = true;
		_iteratorError = err;
	} finally {
		try {
			if (!_iteratorNormalCompletion && _iterator.return) {
				_iterator.return();
			}
		} finally {
			if (_didIteratorError) {
				throw _iteratorError;
			}
		}
	}

	var _iteratorNormalCompletion2 = true;
	var _didIteratorError2 = false;
	var _iteratorError2 = undefined;

	try {
		for (var _iterator2 = Object.entries(config.calendarGroups)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
			var _step2$value = _slicedToArray(_step2.value, 2),
			    calendarGroupId = _step2$value[0],
			    calendarGroup = _step2$value[1];

			if (calendarGroup.aliases) {
				var _iteratorNormalCompletion4 = true;
				var _didIteratorError4 = false;
				var _iteratorError4 = undefined;

				try {
					for (var _iterator4 = calendarGroup.aliases[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
						var _alias = _step4.value;

						aliasMap.set(_alias, calendarGroupId);
					}
				} catch (err) {
					_didIteratorError4 = true;
					_iteratorError4 = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion4 && _iterator4.return) {
							_iterator4.return();
						}
					} finally {
						if (_didIteratorError4) {
							throw _iteratorError4;
						}
					}
				}
			}
		}
	} catch (err) {
		_didIteratorError2 = true;
		_iteratorError2 = err;
	} finally {
		try {
			if (!_iteratorNormalCompletion2 && _iterator2.return) {
				_iterator2.return();
			}
		} finally {
			if (_didIteratorError2) {
				throw _iteratorError2;
			}
		}
	}

	return aliasMap;
}

export function filterHiddenCalendars(config, keys) {

	var isVisible = function isVisible(calendar) {
		return isCalendarVisible(calendar, keys);
	};

	for (var groupId in config.calendarGroups) {
		var group = config.calendarGroups[groupId];
		if (isVisible(group) && group.calendars) group.calendars = group.calendars.filter(function (calendarId) {
			return isVisible(config.calendars[calendarId]);
		});else delete config.calendarGroups[groupId];
	}

	for (var calendarId in config.calendars) {
		var _calendar2 = config.calendars[calendarId];
		if (isVisible(_calendar2)) {
			if (_calendar2.subCalendars) _calendar2.subCalendars = _calendar2.subCalendars.filter(isVisible);
		} else delete config.calendars[calendarId];
	}

	return config;
}

export function replaceCalendarMacros(config) {

	// $FlowFixMe: https://github.com/facebook/flow/issues/2221
	var _iteratorNormalCompletion5 = true;
	var _didIteratorError5 = false;
	var _iteratorError5 = undefined;

	try {
		for (var _iterator5 = Object.values(config.calendarGroups)[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
			var calendarGroup = _step5.value;

			if (calendarGroup.calendars && Array.isArray(calendarGroup.calendars) && calendarGroup.calendars.length === 1 && calendarGroup.calendars[0] === '<all>') calendarGroup.calendars = Object.keys(config.calendars);
		}
	} catch (err) {
		_didIteratorError5 = true;
		_iteratorError5 = err;
	} finally {
		try {
			if (!_iteratorNormalCompletion5 && _iterator5.return) {
				_iterator5.return();
			}
		} finally {
			if (_didIteratorError5) {
				throw _iteratorError5;
			}
		}
	}

	return config;
}

export function getCalendars(calendarId, allCalendars, allCalendarGroups, customCalendar) {

	var calendar = void 0,
	    calendars = [],
	    eventSources = [],
	    calendarMap = {};

	if (calendarId === 'custom') {

		calendar = customCalendar;

		if (customCalendar.calendars) {
			var _eventSources;

			var customCalendars = customCalendar.calendars;
			var actualCalendars = customCalendars.filter(function (id) {
				return id in allCalendars;
			}).map(function (id) {
				return allCalendars[id];
			});

			var _iteratorNormalCompletion6 = true;
			var _didIteratorError6 = false;
			var _iteratorError6 = undefined;

			try {
				for (var _iterator6 = customCalendars[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
					var _calendarId = _step6.value;

					if (!(_calendarId in calendarMap)) calendarMap[_calendarId] = allCalendars[_calendarId];
				}
			} catch (err) {
				_didIteratorError6 = true;
				_iteratorError6 = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion6 && _iterator6.return) {
						_iterator6.return();
					}
				} finally {
					if (_didIteratorError6) {
						throw _iteratorError6;
					}
				}
			}

			calendars.push.apply(calendars, _toConsumableArray(actualCalendars));
			(_eventSources = eventSources).push.apply(_eventSources, _toConsumableArray(actualCalendars.map(function (cal) {
				return getSource(cal);
			})));
		}
	} else if (calendarId in allCalendars) {

		calendar = allCalendars[calendarId];

		if (calendar.googleCalendarId || calendar.source) {
			calendars.push(calendar);
			calendarMap[calendarId] = calendar;
			eventSources.push(getSource(calendar));
		}

		if (calendar.subCalendars && Array.isArray(calendar.subCalendars) && calendar.subCalendars.length > 0) {
			var _eventSources2;

			var subCals = calendar.subCalendars;
			calendars.push.apply(calendars, _toConsumableArray(subCals));
			(_eventSources2 = eventSources).push.apply(_eventSources2, _toConsumableArray(subCals.map(function (subCal) {
				return getSource(subCal);
			})));
		}
	} else if (calendarId in allCalendarGroups) {

		calendar = allCalendarGroups[calendarId];

		if (calendar.calendars) {
			var _eventSources3;

			var calIds = calendar.calendars;
			var cals = calIds.map(function (id) {
				return allCalendars[id];
			});
			calendars.push.apply(calendars, _toConsumableArray(cals));
			(_eventSources3 = eventSources).push.apply(_eventSources3, _toConsumableArray(cals.map(function (cal) {
				return getSource(cal);
			})));
			var _iteratorNormalCompletion7 = true;
			var _didIteratorError7 = false;
			var _iteratorError7 = undefined;

			try {
				for (var _iterator7 = calIds[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
					var calId = _step7.value;

					if (!(calId in calendarMap)) calendarMap[calId] = allCalendars[calId];
				}
			} catch (err) {
				_didIteratorError7 = true;
				_iteratorError7 = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion7 && _iterator7.return) {
						_iterator7.return();
					}
				} finally {
					if (_didIteratorError7) {
						throw _iteratorError7;
					}
				}
			}
		}

		// Add subGroups last
		if (calendar.subGroups) {
			var subGroupIds = calendar.subGroups.filter(function (id) {
				return id in allCalendarGroups && allCalendarGroups[id] !== calendar;
			});
			var _subGroups = subGroupIds.map(function (id) {
				return allCalendarGroups[id];
			});

			var _iteratorNormalCompletion8 = true;
			var _didIteratorError8 = false;
			var _iteratorError8 = undefined;

			try {
				for (var _iterator8 = subGroupIds[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
					var subGroupId = _step8.value;

					if (!(subGroupId in calendarMap)) calendarMap[subGroupId] = allCalendarGroups[subGroupId];
				}
			} catch (err) {
				_didIteratorError8 = true;
				_iteratorError8 = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion8 && _iterator8.return) {
						_iterator8.return();
					}
				} finally {
					if (_didIteratorError8) {
						throw _iteratorError8;
					}
				}
			}

			calendars.push.apply(calendars, _toConsumableArray(_subGroups));

			var _iteratorNormalCompletion9 = true;
			var _didIteratorError9 = false;
			var _iteratorError9 = undefined;

			try {
				var _loop = function _loop() {
					var _eventSources4;

					var subGroup = _step9.value;

					var deepCalendarIds = getDeepCalendarIdsFromSubGroups(subGroup, allCalendars, allCalendarGroups);
					deepCalendarIds = Array.from(new Set(deepCalendarIds));
					var deepCalendars = deepCalendarIds.map(function (id) {
						return allCalendars[id];
					});

					(_eventSources4 = eventSources).push.apply(_eventSources4, _toConsumableArray(deepCalendars.map(function (cal) {
						return getSource(cal, subGroup.color);
					})));
				};

				for (var _iterator9 = _subGroups[Symbol.iterator](), _step9; !(_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done); _iteratorNormalCompletion9 = true) {
					_loop();
				}
			} catch (err) {
				_didIteratorError9 = true;
				_iteratorError9 = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion9 && _iterator9.return) {
						_iterator9.return();
					}
				} finally {
					if (_didIteratorError9) {
						throw _iteratorError9;
					}
				}
			}
		}
	}

	eventSources = dedupeSources(eventSources);

	return { calendar: calendar, calendarMap: calendarMap, calendars: calendars, eventSources: eventSources };
}

export function getSource(calendar) {
	var color = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : calendar.color;

	if (!calendar || !calendar.googleCalendarId && !calendar.source) return {};

	var source = {
		color: color,
		eventDataTransform: function eventDataTransform(eventData) {
			return Object.assign({}, eventData, {
				color: color,
				calendar: calendar
			});
		}
	};

	if (calendar.googleCalendarId && typeof calendar.googleCalendarId === 'string') {
		source.googleCalendarId = calendar.googleCalendarId;
	} else if (calendar.source && typeof calendar.source === 'string') {
		source.url = calendar.source;
	}

	return source;
}

function dedupeSources(sources) {
	// TODO: merge duplicates instead of just using the first one

	var sourceMap = new Map();

	var _iteratorNormalCompletion10 = true;
	var _didIteratorError10 = false;
	var _iteratorError10 = undefined;

	try {
		for (var _iterator10 = sources[Symbol.iterator](), _step10; !(_iteratorNormalCompletion10 = (_step10 = _iterator10.next()).done); _iteratorNormalCompletion10 = true) {
			var _source = _step10.value;

			if (_source.googleCalendarId && !sourceMap.has(_source.googleCalendarId)) sourceMap.set(_source.googleCalendarId, _source);else if (_source.url && !sourceMap.has(_source.url)) sourceMap.set(_source.url, _source);
		}
	} catch (err) {
		_didIteratorError10 = true;
		_iteratorError10 = err;
	} finally {
		try {
			if (!_iteratorNormalCompletion10 && _iterator10.return) {
				_iterator10.return();
			}
		} finally {
			if (_didIteratorError10) {
				throw _iteratorError10;
			}
		}
	}

	return Array.from(sourceMap.values());
}

export function nl2br(text) {
	return text.replace(/(?:\r\n|\r|\n)/g, '<br />');
}

export function ucfirst(str) {
	return str.charAt(0).toUpperCase() + str.substring(1);
}

export function camelCaseToWords(str) {
	var result = '';
	var _iteratorNormalCompletion11 = true;
	var _didIteratorError11 = false;
	var _iteratorError11 = undefined;

	try {
		for (var _iterator11 = str[Symbol.iterator](), _step11; !(_iteratorNormalCompletion11 = (_step11 = _iterator11.next()).done); _iteratorNormalCompletion11 = true) {
			var char = _step11.value;

			if (result === '') {
				result += char.toUpperCase();
			} else if (char === char.toUpperCase()) {
				result += ' ' + char.toLowerCase();
			} else {
				result += char;
			}
		}
	} catch (err) {
		_didIteratorError11 = true;
		_iteratorError11 = err;
	} finally {
		try {
			if (!_iteratorNormalCompletion11 && _iterator11.return) {
				_iterator11.return();
			}
		} finally {
			if (_didIteratorError11) {
				throw _iteratorError11;
			}
		}
	}

	return result;
}

export function rgbaOverRgb(rgba) {
	var rgb = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [255, 255, 255];

	rgba = colorToArray(rgba);
	rgb = colorToArray(rgb);

	if (rgba.length < 4 || rgba[rgba.length - 1] === 1) return colorString.to.rgb(rgba);

	var rgbaAlpha = rgba.pop();

	var resultPieces = [];
	for (var i = 0; i < rgb.length; i++) {
		resultPieces.push(rgb[i] + (rgba[i] - rgb[i]) * rgbaAlpha);
	}

	return colorString.to.rgb(resultPieces);
}

function colorToArray(color) {
	if (Array.isArray(color)) {
		return color;
	} else {
		switch (typeof color === 'undefined' ? 'undefined' : _typeof(color)) {
			case 'object':
				return color.array();
			case 'string':
				return colorString.get(color).value;
		}
	}

	return [];
}

export function fullCalendarToGoogleUrl(event) {
	var url = 'https://calendar.google.com/calendar/render';
	var params = new URLSearchParams();
	params.set('action', 'TEMPLATE');
	params.set('dates', formatCalendarDate(event.start) + '/' + formatCalendarDate(event.end));
	params.set('location', event.location);
	params.set('text', event.title);
	params.set('details', event.description);

	return url + '?' + params.toString();
}

export function fullCalendarToIcs(event) {
	return 'BEGIN:VCALENDAR\nVERSION:2.0\nBEGIN:VEVENT\nURL:' + event.url + '\nDTSTART:' + formatCalendarDate(event.start) + '\nDTEND:' + formatCalendarDate(event.end) + '\nSUMMARY:' + event.title + '\nDESCRIPTION:' + event.description + '\nLOCATION:' + event.location + '\nEND:VEVENT\nEND:VCALENDAR';
}

export function fullCalendarToIcsUrl(event) {
	return encodeURI('data:text/calendar;charset=utf8,' + fullCalendarToIcs(event));
}

function formatCalendarDate(date) {
	return moment(date).toISOString().replace(/-|:|\.\d+/g, '');
}
